/* Copyright (c) 2002 Petr Bilek
  Tento kod program je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne licenese GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor barvy.c */

#include <string.h>

#include "strukturyw.h"
#include "struktury.h"
#include "lib.h"
#include "barvy.h"

barvy_schema bschema;
extern barvy_schema bschema1;	/* definice o par radek nize */

void
barevne ()
{
  unsigned int i;
  barvy_par par;

  switch (global_get (g_barva))
    {
    case 0:			/* black --> defaultni nastaveni */
      bschema = bschema1;
      break;
    case 1:			/* red */
    case 2:			/* green */
    case 3:			/* yellow */
    case 4:			/* blue */
    case 5:			/* magenta */
    case 6:			/* cyan */
      par.fg = global_get (g_barva);
      par.bg = -1;		/* COLOR_BLACK; */
      for (i = 0; i < sizeof (bschema) / sizeof (barvy_par); i++)
	memcpy (((barvy_par *) & bschema) + i, &par, sizeof (par));
      break;
    case 7:			/* white == volba psani -c */
    default:
      par.fg = COLOR_WHITE;
      par.bg = COLOR_BLACK;
      for (i = 0; i < sizeof (bschema) / sizeof (barvy_par); i++)
	memcpy (((barvy_par *) & bschema) + i, &par, sizeof (par));
      break;
#include "profi/barvy-c-schemata.h"
    }
  init_pair2 (COLOR_KLAVESNICE_HLAVNI,
	      bschema.klavesnice.hlavni.fg, bschema.klavesnice.hlavni.bg);
  init_pair2 (COLOR_KLAVESNICE_MALICEK,
	      bschema.klavesnice.malicek.fg, bschema.klavesnice.malicek.bg);
  init_pair2 (COLOR_KLAVESNICE_UKAZOVACEK,
	      bschema.klavesnice.ukazovacek.fg,
	      bschema.klavesnice.ukazovacek.bg);
  init_pair2 (COLOR_KLAVESNICE_PRSTENICEK,
	      bschema.klavesnice.prstenicek.fg,
	      bschema.klavesnice.prstenicek.bg);
  init_pair2 (COLOR_KLAVESNICE_PROSTREDNICEK,
	      bschema.klavesnice.prostrednicek.fg,
	      bschema.klavesnice.prostrednicek.bg);

  init_pair2 (COLOR_NAPOVEDA_HLAVNI, bschema.napoveda.hlavni.fg,
	      bschema.napoveda.hlavni.bg);
  init_pair2 (COLOR_NAPOVEDA_NADPIS, bschema.napoveda.nadpis.fg,
	      bschema.napoveda.nadpis.bg);
  init_pair2 (COLOR_NAPOVEDA_NADPIS2, bschema.napoveda.nadpis2.fg,
	      bschema.napoveda.nadpis2.bg);
  init_pair2 (COLOR_NAPOVEDA_ZAVORKY, bschema.napoveda.zavorky.fg,
	      bschema.napoveda.zavorky.bg);

  init_pair2 (COLOR_NAPOVEDA_UVOZOVKY, bschema.napoveda.uvozovky.fg,
	      bschema.napoveda.uvozovky.bg);
  init_pair2 (COLOR_NAPOVEDA_GNU, bschema.napoveda.gnu.fg,
	      bschema.napoveda.gnu.bg);

  init_pair2 (COLOR_INFOLT_HLAVNI, bschema.infolt.hlavni.fg,
	      bschema.infolt.hlavni.bg);
  init_pair2 (COLOR_INFOLT_KOMENTAR, bschema.infolt.komentar.fg,
	      bschema.infolt.komentar.bg);
  init_pair2 (COLOR_INFOLT_NEMOZNOPSAT, bschema.infolt.nemoznopsat.fg,
	      bschema.infolt.nemoznopsat.bg);
  init_pair2 (COLOR_INFOLT_MOZNOPSAT, bschema.infolt.moznopsat.fg,
	      bschema.infolt.moznopsat.bg);

  init_pair2 (COLOR_NAPOVEDALT_HLAVNI, bschema.napovedalt.hlavni.fg,
	      bschema.napovedalt.hlavni.bg);

  init_pair2 (COLOR_HODNOCENI_HLAVNI, bschema.hodnoceni.hlavni.fg,
	      bschema.hodnoceni.hlavni.bg);

  init_pair2 (COLOR_COPYRIGHT_HLAVNI, bschema.copyright.hlavni.fg,
	      bschema.copyright.hlavni.bg);
  init_pair2 (COLOR_COPYRIGHT_OK, bschema.copyright.ok.fg,
	      bschema.copyright.ok.bg);

  init_pair2 (COLOR_PASSWORD_HLAVNI, bschema.password.hlavni.fg,
	      bschema.password.hlavni.bg);
  init_pair2 (COLOR_PASSWORD_TEXT, bschema.password.text.fg,
	      bschema.password.text.bg);

  init_pair2 (COLOR_DATUM_HLAVNI, bschema.datum.hlavni.fg,
	      bschema.datum.hlavni.bg);

  init_pair2 (COLOR_POZADI_HLAVNI, bschema.pozadi.hlavni.fg,
	      bschema.pozadi.hlavni.bg);

  init_pair2 (COLOR_SUB_NADPIS, bschema.sub.nadpis.fg, bschema.sub.nadpis.bg);

  init_pair2 (COLOR_SUB_HLAVNI, bschema.sub.hlavni.fg, bschema.sub.hlavni.bg);

  init_pair2 (COLOR_SUB_INFORMACE, bschema.sub.informace.fg,
	      bschema.sub.informace.bg);

  init_pair2 (COLOR_SUB_PSANI, bschema.sub.psani.fg, bschema.sub.psani.bg);

  init_pair2 (COLOR_ZADEJTEXT_HLAVNI, bschema.zadejtext.hlavni.fg,
	      bschema.zadejtext.hlavni.bg);
  init_pair2 (COLOR_ZADEJTEXT_TEXT, bschema.zadejtext.text.fg,
	      bschema.zadejtext.text.bg);

  init_pair2 (COLOR_RADEK_HLAVNI, bschema.radek.hlavni.fg,
	      bschema.radek.hlavni.bg);
  init_pair2 (COLOR_RADEK_UHOZU, bschema.radek.uhozu.fg,
	      bschema.radek.uhozu.bg);
  init_pair2 (COLOR_RADEK_CHYBA, bschema.radek.chyba.fg,
	      bschema.radek.chyba.bg);
  init_pair2 (COLOR_RADEK_BEZCHYBY, bschema.radek.bezchyby.fg,
	      bschema.radek.bezchyby.bg);

  init_pair2 (COLOR_VYSLEDKY_HLAVNI, bschema.vysledky.hlavni.fg,
	      bschema.vysledky.hlavni.bg);
  init_pair2 (COLOR_VYSLEDKY_CELKEM, bschema.vysledky.celkem.fg,
	      bschema.vysledky.celkem.bg);
  init_pair2 (COLOR_VYSLEDKY_VYBORNE, bschema.vysledky.vyborne.fg,
	      bschema.vysledky.vyborne.bg);
  init_pair2 (COLOR_VYSLEDKY_DOBRE, bschema.vysledky.dobre.fg,
	      bschema.vysledky.dobre.bg);
  init_pair2 (COLOR_VYSLEDKY_SPATNE, bschema.vysledky.spatne.fg,
	      bschema.vysledky.spatne.bg);

  init_pair2 (COLOR_ZNACEK_HLAVNI, bschema.znacek.hlavni.fg,
	      bschema.znacek.hlavni.bg);
  init_pair2 (COLOR_MENU_HLAVNI, bschema.menu.hlavni.fg,
	      bschema.menu.hlavni.bg);

  init_pair2 (COLOR_BUTTON_HLAVNI, bschema.button.hlavni.fg,
	      bschema.button.hlavni.bg);

#include "profi/barvy-c-pair.h"
}

/* schema skutecnych (defaultnich) barev */
barvy_schema bschema1 = {
  /* barvy_napoveda */
  {
   /* hlavni */ {COLOR_BLACK, COLOR_WHITE}
   ,
   /* nadpis */ {COLOR_BLUE, COLOR_WHITE}
   ,
   /* nadpis2 */ {COLOR_BLUE, COLOR_WHITE}
   ,
   /* zavorky */ {COLOR_GREEN, COLOR_WHITE}
   ,
   /* uvozovky */ {COLOR_RED, COLOR_WHITE}
   ,
   /* gnu */ {COLOR_YELLOW, COLOR_WHITE}
   }
  ,
  /* barvy_vysledky */
  {
   /* hlavni */ {COLOR_BLUE, COLOR_WHITE}
   ,
   /* celkem */ {COLOR_MAGENTA, COLOR_BLACK}
   ,
   /* vyborne */ {COLOR_YELLOW, COLOR_WHITE}
   ,
   /* dobre */ {COLOR_GREEN, COLOR_WHITE}
   ,
   /* spatne */ {COLOR_RED, COLOR_WHITE}
   }
  ,
  /* barvy_button */
  {
   /* pozadi */ {COLOR_GREEN, COLOR_BLACK}
   }
  ,
  /* barvy_copyright */
  {
   /* hlavni */ {COLOR_RED, COLOR_BLACK}
   ,
   /* ok */ {COLOR_GREEN, COLOR_BLACK}
   }
  ,
  /* barvy_pismena */
  {
   /* hlavni */ {COLOR_RED, COLOR_BLACK}
   }
  ,
  /* barvy_klavesnice */
  {
   /* hlavni */ {COLOR_WHITE, COLOR_BLACK}
   ,
   /* malicek */ {COLOR_GREEN, COLOR_BLACK}
   ,
   /* ukazovacek */ {COLOR_BLUE, COLOR_BLACK}
   ,
   /* prstenicek */ {COLOR_YELLOW, COLOR_BLACK}
   ,
   /* prostrednicek */ {COLOR_CYAN, COLOR_BLACK}
   }
  ,
  /* barvy_menu */
  {
   /*hlavni */ {COLOR_MAGENTA, COLOR_BLACK}
   }
  ,
  /* barvy_znacek */
  {
   /* hlavni */ {COLOR_BLUE, COLOR_BLACK}
   }
  ,
  /* barvy_infolt */
  {
   /* hlavni */ {COLOR_YELLOW, COLOR_BLACK}
   ,
   /* moznopsat */ {COLOR_YELLOW, COLOR_BLACK}
   ,
   /* nemoznopsat */ {COLOR_BLUE, COLOR_BLACK}
   ,
   /* komentar */ {COLOR_CYAN, COLOR_BLACK}
   }
  ,
  /* barvy_napovedalt */
  {
   /* hlavni */ {COLOR_YELLOW, COLOR_BLACK}
   }
  ,
  /* barvy_password */
  {
   /* hlavni */ {COLOR_RED, COLOR_BLACK}
   ,
   /* text */ {COLOR_YELLOW, COLOR_BLACK}
   }
  ,
  /* barvy_hodnoceni */
  {
   /* hlavni */ {COLOR_WHITE, COLOR_BLUE}
   }
  ,
  /* barvy_radek */
  {
   /* hlavni */ {COLOR_WHITE, COLOR_BLACK}
   ,
   /* uhozu */ {COLOR_WHITE, COLOR_BLACK}
   ,
   /* chyba */ {COLOR_RED, COLOR_BLACK}
   ,
   /* bezchyby */ {COLOR_GREEN, COLOR_BLACK}
   }
  ,
  /* barvy_datum */
  {
   /* hlavni */ {COLOR_YELLOW, COLOR_BLACK}
   }
  ,
  /* barvy_pozadi */
  {
   /* hlavni */ {COLOR_GREEN, -1}
   }
  ,
  /* barvy_sub */
  {
   /* nadpis */ {COLOR_CYAN, COLOR_BLACK}
   ,
   /* hlavni */ {COLOR_YELLOW, COLOR_BLACK}
   ,
   /* psani */ {COLOR_WHITE, COLOR_BLACK}
   ,
   /* informace */ {COLOR_YELLOW, COLOR_BLACK}
   }
  ,
  /* barvy_zadejtext */
  {
   /* hlavni */ {COLOR_WHITE, COLOR_BLACK}
   ,
   /* text */ {COLOR_BLACK, COLOR_WHITE}
   }
#include "profi/barvy-c-file-manager.h"
};
