/* Copyright (c) 2004 Petr Bilek
   Tento program je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor kontrola_lekce.c */

#include <string.h>
#include "../definice.h"
#include "../struktury.h"
#include "../lib.h"
#include "chlib.h"

int
kontrola_lekce ()
{
  int l, i;
  type_informace info, info2;
  memset(&info2, 0, sizeof(info2));
  printf ("\nKONTROLA INFO LEKCE\n");


  for (l = 1; l <= LEKCE; l++)
    {
      if (nacti_info (l, &info, jmeno_info_lekce ()))
	{
	  fprintf (stderr, "Nelze nacist informace pro LEKCE %i\n", l);
	  return 1;
	}
      if (info.zavislost_na > TEST)
	{
	  fprintf (stderr, "LEKCE %i zavisi na TESTU %i, "
		   "ale testu je jen %i\n", l, info.zavislost_na, TEST);
	  return 1;
	}
      for (i = 1; i < 5; i++)
	if (info.presnost[i] <= info.presnost[i - 1])
	  {
	    fprintf (stderr,
		     "LEKCE %i: presnost nedava smysl (%i <= %i)\n", l,
		     info.presnost[i], info.presnost[i - 1]);
	    return 1;
	  }
      for (i = 1; i < 5; i++)
	if (info.rychlost[i] >= info.rychlost[i - 1])
	  {
	    fprintf (stderr,
		     "LEKCE %i: rychlost nedava smysl (%i >= %i)\n", l,
		     info.rychlost[i], info.rychlost[i - 1]);
	    return 1;
	  }
      if (!obsahuje_vse (info.pismena, info.nove_pismena, 1))
	{
	  fprintf (stderr,
		   "LEKCE %i: pismena neobsahuji vsechny nove_pismena\n", l);
	  return 1;
	}
      if (l > 1)
	{
	  if (!obsahuje_vse (info.pismena, info2.pismena, 1))
	    {
	      fprintf (stderr,
		       "LEKCE %i neobsahuje vsechny pismana LEKCE %i\n",
		       l, l - 1);
	    }

	  if (info.zavislost_na < info2.zavislost_na)
	    {
	      fprintf (stderr, "LEKCE %i zavisi na testu %i, ale "
		       "LEKCE %i na testu %i\n", l, info.zavislost_na,
		       l - 1, info2.zavislost_na);
	      if (l == LEKCER)
		fprintf (stderr, "(je to prvni lekce na rychlost, OK)\n");
	      else
		return 1;
	    }
	  if (!info.mezernik && info2.mezernik)
	    fprintf (stderr, "LEKCI %i lze ukoncit mezernikem, ale "
		     "LEKCI %i nelze!\n", l - 1, l);
	  for (i = 0; i < 5; i++)
	    if (info.presnost[i] > info2.presnost[i])
	      {
		fprintf (stderr,
			 "LEKCE %i/%i: presnost nedava smysl (%i > %i)\n",
			 l, l - 1, info.presnost[i], info2.presnost[i]);
	      }
	  for (i = 0; i < 5; i++)
	    if (info.rychlost[i] < info2.rychlost[i])
	      {
		fprintf (stderr,
			 "LEKCE %i/%i: rychlost nedava smysl (%i < %i)\n",
			 l, l - 1, info.rychlost[i], info2.rychlost[i]);
	      }
	}
      info2 = info;
    }
  return 0;
}
