/* Copyright (c) 2004 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor nactislozku_30.c PROFI */
#ifdef PSANIPROFI

#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>
#include "definice.h"
#include "struktury.h"
#include "lib.h"
#include "nactislozku_30.h"

typedef struct
{
  unsigned int presnost[5][2];
  unsigned int rychlost[5][2];
  short int test;		/* zobrazovani psaneho radku 0 = ano / 1 = ne */
  short int mezernik;		/* 1 = ukoncovani i mezernikem */
} type_vtext_30;

typedef struct
{
  char verse[10];
  short int metronom;
  short int napsano_odstavec[100];
  short int napsano_lekce[100];

  short int napsano_test[80];
  time_t datum_test[3][80];	/* kdy byl test psan */

  short int uh_min[3][80];
  unsigned short int chyb_test[3][80];
  unsigned short int vterin_test[3][80];
  float znamka_test[3][3][80];

  char jmeno[25];
  char heslo[25];
  unsigned int heslo_I;

  type_vtext_30 vtext;		/* volny_text */
  short int qwertz;
  short int us;
  short int ZATIM_NIC;
} type_uziv_30;


char *
jmeno_souboru_30 (void)
{
  static char slozka[STRING_MAX];
  struct passwd *pw;
  pw = getpwuid (getuid ());
  if (pw == NULL)
    return NULL;

  snprintf (slozka, STRING_MAX, "%s/.sallyx/psani/3.0.00/slozka.dat",
	    pw->pw_dir);
  return slozka;
}


int
nacti_slozku_30 (type_uziv_30 * slozka)
{
  FILE *soubor;

  if ((soubor = fopen (jmeno_souboru_30 (), "rb")) == NULL)
    return 1;

  if (fread (slozka, sizeof (type_uziv_30), 1, soubor) != 1 ||
      strcmp (slozka->verse, "3.0.00"))
    {
      if (fclose (soubor) && (global_get (g_warning) == g_w_ano))
	perror ("fclose()");
      if (strcmp (slozka->verse, "3.0.00") &&
	  (global_get (g_warning) == g_w_ano))
	fprintf (stderr, "Chybna verze souboru \"%s\"\nVerze ma byt %s,"
		 "ale je \"%s\"\n", jmeno_souboru_30 (), "3.0.00",
		 slozka->verse);
      else if (global_get (g_warning) == g_w_ano)
	fprintf (stderr, "Nepodarilo se nacist vsechna data ze souboru"
		 " \"%s\"\n", jmeno_souboru_30 ());

      return 1;
    }
  if (fclose (soubor) && (global_get (g_warning) == g_w_ano))
    perror ("fclose()");
  return 0;
}

void
kompatibilita_30 (type_uziv * slozka, type_nastaveni * nastaveni)
{
  type_uziv_30 slozka_30;
  short int i, j;

  if (nacti_slozku_30 (&slozka_30))
    {
      print_hl (2, "Poznmka: Star verze dat (\"3.0.00\")"
		" nebyla nalezena.", "\n");
      return;
    }

  print_hl (1, "Byla nalezena data verze \"3.0.00\", konvertuji ...");
  implicitni_nastaveni (nastaveni);

  nastaveni->metronom = slozka_30.metronom;
  nastaveni->qwertz = slozka_30.qwertz;
  nastaveni->us = slozka_30.us;
  nastaveni->vtext.test = slozka_30.vtext.test;
  nastaveni->vtext.mezernik = slozka_30.vtext.mezernik;

  for (i = 0; i < 100; i++)
    {
      if (i >= MAXLEKCE)
	break;
      slozka->napsano_odstavec[i] = slozka_30.napsano_odstavec[i];
      slozka->napsano_lekce[i] = slozka_30.napsano_lekce[i];
    }
  for (i = 0; i < 80; i++)
    {
      if (i >= MAXTEST)
	break;
      slozka->napsano_test[i] = slozka_30.napsano_test[i];
      for (j = 0; j < 3; j++)
	{
	  if (j >= POKUSU)
	    return;
	  slozka->datum_test[j][i] = slozka_30.datum_test[j][i];
	  slozka->uh_min[j][i] = slozka_30.uh_min[j][i];
	  slozka->chyb_test[j][i] = slozka_30.chyb_test[j][i];
	  slozka->vterin_test[j][i] = slozka_30.vterin_test[j][i];
	  slozka->znamka_test[j][0][i] = slozka_30.znamka_test[j][0][i];
	  slozka->znamka_test[j][1][i] = slozka_30.znamka_test[j][1][i];
	  slozka->znamka_test[j][2][i] = slozka_30.znamka_test[j][2][i];
	}
    }
  strncpy (slozka->jmeno, slozka_30.jmeno,
	   sizeof (slozka->jmeno) / sizeof (char));

  uloz_slozku (slozka);
  uloz_nastaveni (nastaveni);
}
#endif /* PSANIPROFI */
