/* Copyright (c) 2003 Petr Bilek
Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor vl_sporic.c PROFI */
#ifdef PSANIPROFI

#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <pthread.h>
#include <time.h>

#include "struktury.h"
#include "lib.h"

#define CEKEJ 5U
#ifdef vlfasldfkjas
void *sporic (void *);
WINDOW *wsporic;
chtype *obrazovka;
static pthread_t vlakno;
extern time_t posledni_stisk_klavesy;
unsigned char sporic_spusten = 0;

void
ukonci_vlakno_sporice (void)
{
  int res;
  if (pthread_cancel (vlakno))
    {
      if (global_warning (-1))
	print_hl (1, "Ukoncovani sporice selhalo.");
    }
  res = pthread_join (vlakno, NULL);
  odeber_z_priority (wsporic);
  sporic_spusten = 0;
  if (res != 0)
    if (global_warning (-1))
      print_hl (1, "Chyba ukonceni vlakna sporice!");
  print_hl (1, "Sporic ukoncen.");
  delwin2 (wsporic);
  free (obrazovka);
  tiskni_dle_priority ();
}

void *
vl_sporic (void *arg)
{
  int res, x, y;

  x = pthread_setcanceltype (PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
  if (x && (global_get (g_warning) == g_w_ano))
    {
      print_hl (1,
		"vl_sporic: Selhalo nastaveni priznaku ukonceni funkce varovani");
      return NULL;
    }
  /* nejdrive nastavime posledni stisk klavesy na "ted", aby se
   * sporic nespustil hned pri startu programu */

  posledni_stisk_klavesy = time (NULL);
  do
    {
      sleep ((unsigned int) (1));
      pthread_testcancel ();
      if (((time (NULL) - posledni_stisk_klavesy) < CEKEJ) || sporic_spusten)
	continue;
      sporic_spusten = 1;
      print_hl (1, "Spoustim sporic obrazovky.");
      /* nastaveni obrazovky */
      if ((obrazovka = calloc (COLS * LINES, sizeof (obrazovka[0]))) == NULL)
	{
	  print_hl (1, "CHYBA: Nedostatek pamti");
	  if (global_warning (-1))
	    perror ("vl_sporic()");
	  pthread_exit (0);
	}
      cteni_obrazovky (obrazovka);
      if ((wsporic = newwin2 (LINES, COLS, 0, 0)) == NULL)
	{
	  print_hl (1, "CHYBA: Nedostatek pamti (2)");
	  if (global_warning (-1))
	    perror ("vl_sporic()");
	  pthread_exit (0);
	}

      for (y = 0; y < LINES; y++)
	for (x = 0; x < COLS; x++)
	  mvwaddch2 (wsporic, y, x, obrazovka[y * COLS + x]);

      srand (time (NULL));
      /* spusteni  vlakna sporice */
      res = pthread_create (&vlakno, NULL, sporic, NULL);
      if (res != 0)
	if (global_warning (-1))
	  {
	    print_hl (1,
		      "Chyba spusteni \"sporic (2)\" --> ukoncete program!");
	    pthread_exit (0);
	  }
      pridej_do_priority_w (2, wsporic, stdscr, LINES - 1, 0);
    }
  while (1);
  pthread_exit (0);
}

void *
sporic (void *arg)
{
  chtype pismeno;
  int x, y, x2, y2;
  char *SPORIC =
    "SPOI OBRAZOVKY - stisknte libovolnou klvesu pro vypnut.";

  if (pthread_setcancelstate (PTHREAD_CANCEL_ENABLE, NULL) != 0)
    {
      if (global_warning (-1))
	print_hl (1, "sporic(): Chyba pthread_setcancelstate()");
      pthread_exit (0);
    }
  if (pthread_setcanceltype (PTHREAD_CANCEL_DEFERRED, NULL) != 0)
    {
      if (global_warning (-1))
	print_hl (1, "sporic(): Chyba pthread_setcanceltype()");
      pthread_exit (0);
    }

  do
    {
      usleep (500);
      pthread_testcancel ();
      x = rand () % (COLS);
      y = rand () % (LINES);
      x2 = rand () % (COLS);
      y2 = rand () % (LINES);
      if (((y == 0) || (y2 == 0)) && ((x < strlen (SPORIC)) ||
				      (x2 < strlen (SPORIC))))
	continue;
      pismeno = mvwinch2 (wsporic, y, x);
      mvwaddch2 (wsporic, y, x, mvwinch2 (wsporic, y2, x2));
      mvwaddch2 (wsporic, y2, x2, pismeno);
      mvwprintw2 (wsporic, 0, 0, SPORIC);
      tiskni_dle_priority ();
    }
  while (1);
  pthread_exit (0);
}
#endif /*fasdfas */
#endif /* PSANIPROFI */
