/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor zadejtext.c */

#include <stdlib.h>
#include <errno.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"

/* funkce zadej_text vraci 0 v pripade chyby */
int
zadej_text (char *pole, int delka, int y, int x, bool sipky, bool heslo)
{
  return wzadej_text (NULL, pole, delka, y, x, sipky, heslo);
}

int
wzadej_text (WINDOW * win, char *pole, int delka, int y, int x,
	     bool sipky, bool heslo)
{
  int i;
  /* char pom[2]; */
  int ch = '*';
  WINDOW *new_zadejt;
  chtype bgChar = ACS_CKBOARD;

  /* pom[1] = '\0'; */

  if (global_get (g_box))
    bgChar = '#';

  if (win == NULL)
    {
      new_zadejt = newwin2 (1, delka, y, x);
    }
  else
    {
      new_zadejt = derwin (win, 1, delka, y, x);
    }
  if (new_zadejt == NULL)
    {
      print_hl (1, "CHYBA: Nelze zadavat text! Okno nelze vyvorit.");
      if (global_get (g_warning) == g_w_ano)
	perror ("zadej_text()");
      return (char) 0;
    }

  wattron2 (new_zadejt, COLOR_PAIR (COLOR_ZADEJTEXT_HLAVNI));

  for (i = 0; i < delka - 1; i++)
    {
      mvwaddch2 (new_zadejt, 0, i, bgChar);
    }
  mvwaddch2 (new_zadejt, 0, delka - 1, ' ');

  wattron2 (new_zadejt, COLOR_PAIR (COLOR_ZADEJTEXT_TEXT));

  if (!heslo)
    mvwprintw2 (new_zadejt, 0, 0, pole);

  i = strlen (pole);
  pridej_do_priority_w (1, new_zadejt, new_zadejt, 0, i);
  do
    {
      odeber_z_priority (new_zadejt);
      pridej_do_priority_w (1, new_zadejt, new_zadejt, 0, i);
      tiskni_dle_priority ();

      ch = getch3 ();
      if ((ch == KEY_DOWN || ch == KEY_UP) && sipky)
	{
	  pole[i] = '\0';
	  break;
	}
      if (((ch <= 'z' && ch >= 'a') || (ch <= 'Z' && ch >= 'A')
	   || cestina (ch) || (ch <= '?' && ch >= '!')
	   || (ch == ' ') || (ch == '_') || (ch == '[')
	   || (ch == '\\') || (ch == '') || (ch == ']')) && (i < delka - 1))
	{
	  pole[i++] = (char) ch;
	  /*pom[0] = (char) ch; */
	  /* mvwaddch2(new_zadejt, 0, i - 1, ch); // ?***** */
	  MVWPRINTW2 (new_zadejt, 0, i - 1, "%c", heslo ? '*' : (char) ch);
	}
      else if (ch == KEY_BACKSPACE)
	{
	  if (i != 0)
	    {
	      wattron2 (new_zadejt, COLOR_PAIR (COLOR_ZADEJTEXT_HLAVNI));
	      mvwaddch2 (new_zadejt, 0, --i, bgChar);	/* ?***** */
	      pole[i] = '\0';
	      wattron2 (new_zadejt, COLOR_PAIR (COLOR_ZADEJTEXT_TEXT));
	    }
	}
      else if (ch != '\n')
	{
	  if (i < delka - 2)
	    {
	      if (ch != KEY_RESIZE)
		print_hl (4, "\"", keyname (ch), "\"", " Neppustn znak!");
	    }
	  else
	    print_hl (1,
		      "Pli mnoho znak. Stisknte BACKSPACE pro smazn poslednho znaku.");
	  tiskni_dle_priority ();
	}
    }
  while (ch != '\n');
  pole[i] = '\0';

  odeber_z_priority (new_zadejt);
  delwin2 (new_zadejt);
  return ch;
}
